package com.io.yutian.enderdragonwar;

import com.io.yutian.enderdragonwar.game.Game;
import com.io.yutian.enderdragonwar.game.GameSetting;
import com.io.yutian.pixelliveapi.api.PixelLiveAPI;
import com.io.yutian.enderdragonwar.listener.GameListener;
import com.io.yutian.enderdragonwar.listener.LiveListener;
import com.io.yutian.enderdragonwar.listener.PlayerListener;
import com.io.yutian.enderdragonwar.manager.GiftEffectManager;
import org.bukkit.Bukkit;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.bukkit.plugin.java.JavaPlugin;

public class EnderDragonWar extends JavaPlugin {

    private static EnderDragonWar instance;
    private static Game game;

    @Override
    public void onEnable() {
        instance = this;

        if (!PixelLiveAPI.isInitialized()) {
            Bukkit.getPluginManager().disablePlugin(this);
            return;
        }

        GiftEffectManager.registerAll();
        GameSetting.load();

        game = new Game();

        Bukkit.getPluginManager().registerEvents(new PlayerListener(), this);
        Bukkit.getPluginManager().registerEvents(new GameListener(), this);
        Bukkit.getPluginManager().registerEvents(new LiveListener(), this);
    }

    @Override
    public boolean onCommand(CommandSender sender, Command command, String Command, String[] args) {
        if (args.length == 1 && args[0].equalsIgnoreCase("start")) {
            Player player = (Player) sender;
            game.startGame(player);
            return true;
        }
        return true;
    }

    public static EnderDragonWar inst() {
        return instance;
    }

    public static Game getGame() {
        return game;
    }

}
