package com.io.yutian.enderdragonwar.effect.types;

import com.io.yutian.enderdragonwar.EnderDragonWar;
import com.io.yutian.enderdragonwar.effect.GameGiftEffect;
import com.io.yutian.enderdragonwar.game.Game;
import com.io.yutian.pixelliveapi.api.PixelLiveAPI;
import com.io.yutian.pixelliveapi.api.data.RandomBoxEntry;
import com.io.yutian.pixelliveapi.api.util.RandomBoxHelper;
import org.bukkit.Bukkit;
import org.bukkit.Sound;
import org.bukkit.entity.Player;
import org.bukkit.scheduler.BukkitRunnable;
import org.bukkit.scheduler.BukkitTask;

public class RandomBoxEffect extends GameGiftEffect {

    public RandomBoxEffect(String audience) {
        super(audience);
    }

    @Override
    public void apply(Game game) {
        Player player = game.getPlayer();
        RandomBoxHelper randomBoxHelper = PixelLiveAPI.getRandomBoxManager().getRandomBoxHelper();
        BukkitTask task = new BukkitRunnable() {
            private int i = 0;
            @Override
            public void run() {
                RandomBoxEntry randomBoxEntry = randomBoxHelper.getRandomEffect();
                if (i >= 12) {
                    player.sendTitle("§6随机盲盒", "§9整蛊效果: §e" + randomBoxEntry.getShowName());
                    player.playSound(player.getLocation(), Sound.BLOCK_COMPARATOR_CLICK, 1, 1);
                    PixelLiveAPI.getEffectQueueManager().addEffect(getAudience(), randomBoxEntry.getEffect(), 1);
                    Bukkit.broadcastMessage("§c[消息]§a随机盲盒抽中了 §e" + randomBoxEntry.getShowName());
                    cancel();
                    return;
                }
                player.sendTitle("§6随机盲盒", "§9整蛊效果: §e" + randomBoxHelper.getRandomEffect().getShowName());
                player.playSound(player.getLocation(), Sound.BLOCK_COMPARATOR_CLICK, 1, 1);
                i++;
            }
        }.runTaskTimer(EnderDragonWar.inst(), 0L, 5L);
        EnderDragonWar.getGame().addTasks(task);
    }

    @Override
    public int getQueueTime() {
        return 12 * 5;
    }

}
