package com.io.yutian.enderdragonwar.effect.types;

import com.io.yutian.enderdragonwar.EnderDragonWar;
import com.io.yutian.enderdragonwar.data.Region;
import com.io.yutian.enderdragonwar.game.Game;
import com.io.yutian.enderdragonwar.util.BuildSpawner;
import com.sk89q.worldedit.EditSession;
import com.sk89q.worldedit.WorldEdit;
import com.sk89q.worldedit.bukkit.BukkitAdapter;
import com.sk89q.worldedit.function.operation.Operations;
import com.sk89q.worldedit.math.BlockVector3;
import com.sk89q.worldedit.regions.CuboidRegion;
import com.io.yutian.enderdragonwar.effect.GameGiftEffect;
import org.bukkit.Location;
import org.bukkit.Material;
import org.bukkit.World;
import org.bukkit.entity.Player;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Iterator;
import java.util.List;

public class SpawnEnderPortalEffect extends GameGiftEffect {

    private static final List<Material> MATERIAL_LIST = Arrays.asList(Material.WHITE_WOOL, Material.BLACK_WOOL, Material.BROWN_WOOL, Material.BLUE_WOOL, Material.GREEN_WOOL, Material.RED_WOOL, Material.YELLOW_WOOL, Material.PURPLE_WOOL, Material.ORANGE_WOOL, Material.PINK_WOOL, Material.LIGHT_BLUE_WOOL, Material.LIME_WOOL);

    public static List<Region> enderPortalRegions = new ArrayList<>();

    public SpawnEnderPortalEffect(String audience) {
        super(audience);
    }

    public static void checkPortalRegion(Location location) {
        Iterator<Region> iterator = enderPortalRegions.iterator();
        while (iterator.hasNext()) {
            Region region = iterator.next();
            if (region.isInRegion(location)) {
                com.sk89q.worldedit.world.World weWorld = BukkitAdapter.adapt(region.getWorld());
                BlockVector3 vector0 = BlockVector3.at(region.getMin().getBlockX(), region.getMin().getBlockY(), region.getMin().getBlockZ());
                BlockVector3 vector1 = BlockVector3.at(region.getMax().getBlockX(), region.getMax().getBlockY(), region.getMax().getBlockZ());
                CuboidRegion cuboidRegion0 = new CuboidRegion(weWorld, vector0, vector1);
                try (EditSession editSession = WorldEdit.getInstance().newEditSession(BukkitAdapter.adapt(region.getWorld()))) {
                    editSession.setBlocks((com.sk89q.worldedit.regions.Region) cuboidRegion0, BukkitAdapter.asBlockType(Material.AIR));
                    Operations.complete(editSession.commit());
                } catch (Exception e) {
                }
                iterator.remove();
            }
        }
    }

    @Override
    public void apply(Game game) {
        int chunkWight = 2;
        int chunkLength = 2;
        int ladderLength = 3;
        int ladderAmount = 5;
        int platformWidth = 3;
        int platformLength = 7;
        int levelAmount = 15;
        EnderDragonWar.getGame().takeLiveTime(60 * 6);
        World world = game.getWorld();
        Player player = game.getPlayer();
        Location location = player.getLocation();
        BuildSpawner buildSpawner = new BuildSpawner(world, BuildSpawner.Direction.NORTH, location.getBlockX(), location.getBlockY() - 1, location.getBlockZ(), chunkWight, chunkLength, ladderLength, ladderAmount, platformWidth, platformLength, levelAmount, BuildSpawner.SpawnMode.MODE_2, MATERIAL_LIST);
        Region region = buildSpawner.getEffectiveRegion(world);
        for (int x = region.getMin().getBlockX(); x <= region.getMax().getBlockX(); x++) {
            for (int y = region.getMin().getBlockY(); y <= region.getMax().getBlockY(); y++) {
                for (int z = region.getMin().getBlockZ(); z <= region.getMax().getBlockZ(); z++) {
                    if (world.getBlockAt(x, y, z).getType() != Material.AIR) {
                        world.getBlockAt(x, y, z).setType(Material.AIR);
                    }
                }
            }
        }
        enderPortalRegions.add(region);
        buildSpawner.spawn();
    }

}
