package com.io.yutian.enderdragonwar.listener;

import com.io.yutian.enderdragonwar.EnderDragonWar;
import com.io.yutian.enderdragonwar.game.GameSetting;
import org.bukkit.entity.Creeper;
import org.bukkit.entity.EnderDragon;
import org.bukkit.entity.LightningStrike;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.entity.EntityDamageByEntityEvent;
import org.bukkit.event.entity.EntityDeathEvent;
import org.bukkit.event.entity.PlayerDeathEvent;
import org.bukkit.event.player.PlayerJoinEvent;
import org.bukkit.event.player.PlayerQuitEvent;
import org.bukkit.event.server.ServerListPingEvent;
import org.bukkit.scheduler.BukkitRunnable;

public class GameListener implements Listener {

    @EventHandler
    public void onPing(ServerListPingEvent event) {
        event.setMotd("§a整蛊模式: §6生存挑战  §a当前版本: §6常规版 §b运行中");
    }

    @EventHandler
    public void onPlayerJoin(PlayerJoinEvent event) {
        Player player = event.getPlayer();
        EnderDragonWar.getGame().startGame(player);
    }

    @EventHandler
    public void onPlayerQuit(PlayerQuitEvent event) {
        EnderDragonWar.getGame().quitGame(event.getPlayer());
    }

    @EventHandler
    public void onDamage(EntityDamageByEntityEvent event) {
        if (event.getEntity() instanceof Player) {
            if (event.getDamager() instanceof LightningStrike) {
                event.setDamage(1.0);
            } else if (event.getDamager() instanceof Creeper creeper) {
                event.setDamage(creeper.isPowered() ? 4.0 : 2.0);
            }
        } else if (event.getEntity() instanceof LightningStrike) {
            if (!(event.getDamager() instanceof Player player)) {
                event.setDamage(2.0);
            }
        } else if (event.getDamager() instanceof Creeper creeper) {
            if (!(event.getEntity() instanceof Player)) {
                event.setDamage(creeper.isPowered() ? 4.0 : 2.0);
            }
        }
    }

    @EventHandler
    public void onDeath(PlayerDeathEvent event) {
        event.setDeathMessage(null);
        Player player = event.getEntity();
        new BukkitRunnable() {
            private int i = 0;

            public void run() {
                if (i == 1) {
                    player.spigot().respawn();
                }
                if (i == 3) {
                    int t = GameSetting.getDeathAddTime();
                    EnderDragonWar.getGame().addLiveTime(t);
                    player.sendTitle("§4你嘎了", "§e加播"+t+"分钟！");
                    cancel();
                }
                i++;
            }
        }.runTaskTimer(EnderDragonWar.inst(), 0L, 2L);
    }

    @EventHandler
    public void onEntityDeath(EntityDeathEvent event) {
        if (event.getEntity() instanceof EnderDragon) {
            EnderDragonWar.getGame().takeLiveTime(60);
        }
    }

}
