package com.io.yutian.enderdragonwar.listener;

import com.io.yutian.enderdragonwar.EnderDragonWar;
import com.io.yutian.enderdragonwar.game.GameSetting;
import com.io.yutian.pixelliveapi.api.PixelLiveAPI;
import com.io.yutian.pixelliveapi.api.data.Anchor;
import com.io.yutian.pixelliveapi.api.data.Audience;
import com.io.yutian.pixelliveapi.api.data.Gift;
import com.io.yutian.pixelliveapi.api.effect.GiftEffectData;
import com.io.yutian.pixelliveapi.api.event.AnchorInitializedEvent;
import com.io.yutian.pixelliveapi.api.event.LiveEnterRoomEvent;
import com.io.yutian.pixelliveapi.api.event.LiveGiftEvent;
import com.io.yutian.pixelliveapi.api.event.LiveLikeEvent;
import com.io.yutian.enderdragonwar.util.GameUtil;
import com.io.yutian.enderdragonwar.util.RandomUtil;
import net.kyori.adventure.text.Component;
import org.bukkit.Bukkit;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;

public class LiveListener implements Listener {

    @EventHandler
    public void onInit(AnchorInitializedEvent event) {
        Anchor anchor = event.getAnchor();
        anchor.getClient().connect();
    }

    @EventHandler
    public void onLiveEnter(LiveEnterRoomEvent event) {
        Player zhubo = event.getPlayer();
        Audience audience = event.getAudience();
        String userName = "" + RandomUtil.getRandomInt(999, 10000);
        if (audience.getNickName() != null) {
            userName = audience.getNickName();
        }
        zhubo.sendActionBar(Component.text("§6" + GameUtil.hideName(userName) + "来了"));
    }

    @EventHandler
    public void onLiveLike(LiveLikeEvent event) {
        Player zhubo = event.getPlayer();
        String userName = "" + RandomUtil.getRandomInt(999, 10000);
        Audience audience = event.getAudience();
        if (audience.getNickName() != null) {
            userName = audience.getNickName();
        }
        int count = event.getClickCount();
        EnderDragonWar.getGame().addDianZan(count);
        if (EnderDragonWar.getGame().getDianZan() >= GameSetting.getDianzanAmount()) {
            String event1 = GameSetting.getDianzanEffect();
            String title = "§c" + event1;
            String subtitle = "§9双击屏幕x" + GameSetting.getDianzanAmount();
            zhubo.sendTitle(title, subtitle, 10, 30, 10);
            PixelLiveAPI.getEffectQueueManager().addEffect(userName, event1, 1);
            EnderDragonWar.getGame().setDianZan(0);
        }
    }
    
    @EventHandler
    public void onLiveGift(LiveGiftEvent event) {
        Player zhubo = event.getPlayer();
        Audience audience = event.getAudience();
        String userName = audience.getNickName();
        Gift gift = event.getGift();
        String giftName = gift.getName();
        int giftAmount = event.getCount();
        String hideUserName = GameUtil.hideName(userName);
        if (!PixelLiveAPI.getGiftManager().hasGiftData(giftName)) {
            return;
        }
        GiftEffectData giftEffectData = PixelLiveAPI.getGiftManager().getGiftData(giftName);
        String effect = giftEffectData.getEffect();
        String title = "§c" + effect;
        if (giftAmount >= 2) {
            title = "§c" + effect + " x" + giftAmount;
        }
        String subtitle = "§9" + giftName;
        zhubo.sendTitle(title, subtitle, 0, 30, 10);
        for (Player player : Bukkit.getOnlinePlayers()) {
            player.sendMessage("§a礼物: §e" + hideUserName + " §d送来了 §e" + giftName + "x" + giftAmount);
        }
        EnderDragonWar.inst().getLogger().info("§a礼物: §e" + hideUserName + " §d送来了 §e" + giftName + "x" + giftAmount);
    }

}
